using Exferia_Aplicacion.Herencia.Capas;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using System.Runtime.CompilerServices;
using Exferia_General;
using Exferia_HotelPuntoVenta._0_Modelos;
using Exferia_Aplicacion.Modelos_MantenimientoSimple;
using System.Transactions;
using System.Data.SqlClient;

namespace Exferia_HotelPuntoVenta._1_Datos
{
    public class HPV_Perfiles_Datos : ABS_Datos
    {
        #region Listado
        private List<INTERNO_HPV_Perfiles_Listado_Modelo> g_lst_INTERNO_HPV_Perfiles_Listado_Modelo = null;

        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            List<dynamic> lst_HPV = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(HPV_Perfiles).Name), _lst_CamposConRelacionABuscar, -1, null, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_HPV_Perfiles_Listado_Modelo != null) && (g_lst_INTERNO_HPV_Perfiles_Listado_Modelo.Count() > 0))
                {
                    lst_HPV = g_lst_INTERNO_HPV_Perfiles_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Perfiles_Datos) + "/" + nameof(Obtener_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lst_HPV;
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_HPV = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(HPV_Perfiles).Name), _lst_CamposConRelacionABuscar, _lng_id, _lst_ids, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_HPV_Perfiles_Listado_Modelo != null) && (g_lst_INTERNO_HPV_Perfiles_Listado_Modelo.Count() > 0))
                {
                    dnm_HPV = g_lst_INTERNO_HPV_Perfiles_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Perfiles_Datos) + "/" + nameof(Obtener_RegistroListado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_HPV;
        }
        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                string str_Filtros_Empresas = Funciones.Formar_ContenidoIN_ParaConsultaWhere(_lst_idEmpresasRelacionadas);

                //Filtros de Opciones
                //Datos del Padre si los tuviera .........................
                long lng_Padre_id = -1;
                string str_Padre_Opcion = "";
                if (_lst_INTERNO_Filtro_OpcionPadre_Modelo != null && _lst_INTERNO_Filtro_OpcionPadre_Modelo.Count > 0)
                {
                    lng_Padre_id = _lst_INTERNO_Filtro_OpcionPadre_Modelo[0].VALOR;
                    str_Padre_Opcion = _lst_INTERNO_Filtro_OpcionPadre_Modelo[0].NOMBRE_CAMPO;
                }

                string str_SQL =
                      " SELECT " +
                          nameof(INTERNO_HPV_Perfiles_Listado_Modelo.id) + " = " + nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.id) + "," +
                          nameof(INTERNO_HPV_Perfiles_Listado_Modelo.codigo) + " = " + nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.codigo) + "," +
                          nameof(INTERNO_HPV_Perfiles_Listado_Modelo.descripcion) + " = " + nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.descripcion) + "," +
                          //ids
                          nameof(INTERNO_HPV_Perfiles_Listado_Modelo.idEmpresa) + " = " + nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.idEmpresa) + "," +
                          nameof(INTERNO_HPV_Perfiles_Listado_Modelo.idAgrupacionPLVCabecera) + " = " + nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.idAgrupacionPLVCabecera) + "," +
                          //Empresa
                          (
                            (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_HPV_Perfiles_Listado_Modelo.Empresa)))
                              ?
                                  (
                                      nameof(INTERNO_HPV_Perfiles_Listado_Modelo.Empresa_Codigo) + " = " + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.codigo) + "," +
                                      nameof(INTERNO_HPV_Perfiles_Listado_Modelo.Empresa_Descripcion) + " =" + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.descripcion) + "," +
                                      nameof(INTERNO_HPV_Perfiles_Listado_Modelo.Empresa_FechaBorrado) + " =" + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.fechaBorrado) + ","
                                  )
                              :
                                  (
                                      nameof(INTERNO_HPV_Perfiles_Listado_Modelo.Empresa_Codigo) + " = ''," +
                                      nameof(INTERNO_HPV_Perfiles_Listado_Modelo.Empresa_Descripcion) + " = ''," +
                                      nameof(INTERNO_HPV_Perfiles_Listado_Modelo.Empresa_FechaBorrado) + " = NULL, "
                                  )
                          ) +
                          //AgrupacionPLVCabecera
                          (
                            (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_HPV_Perfiles_Listado_Modelo.AgrupacionPLVCabecera)))
                              ?
                                  (
                                      nameof(INTERNO_HPV_Perfiles_Listado_Modelo.AgrupacionPLVCabecera_Codigo) + " = " + nameof(HPV_AgrupacionesPLVCabeceras) + "." + nameof(HPV_AgrupacionesPLVCabeceras.codigo) + "," +
                                      nameof(INTERNO_HPV_Perfiles_Listado_Modelo.AgrupacionPLVCabecera_Descripcion) + " =" + nameof(HPV_AgrupacionesPLVCabeceras) + "." + nameof(HPV_AgrupacionesPLVCabeceras.descripcion) + "," +
                                      nameof(INTERNO_HPV_Perfiles_Listado_Modelo.AgrupacionPLVCabecera_FechaBorrado) + " =" + nameof(HPV_AgrupacionesPLVCabeceras) + "." + nameof(HPV_AgrupacionesPLVCabeceras.fechaBorrado)
                                  )
                              :
                                  (
                                      nameof(INTERNO_HPV_Perfiles_Listado_Modelo.AgrupacionPLVCabecera_Codigo) + " = ''," +
                                      nameof(INTERNO_HPV_Perfiles_Listado_Modelo.AgrupacionPLVCabecera_Descripcion) + " = ''," +
                                      nameof(INTERNO_HPV_Perfiles_Listado_Modelo.AgrupacionPLVCabecera_FechaBorrado) + " = NULL "
                                  )
                          ) +
                " FROM " + nameof(HPV_Perfiles) +
                      //Empresa
                      (
                           (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_HPV_Perfiles_Listado_Modelo.Empresa)))
                              ?
                                  (
                                   " LEFT JOIN " + nameof(GEN_Empresas) + " ON " + nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.idEmpresa) + " = " + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.id)
                                  )
                              : ("")
                      ) +
                      //AgrupacionPLVCabecera
                      (
                           (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_HPV_Perfiles_Listado_Modelo.AgrupacionPLVCabecera)))
                              ?
                                  (
                                   " LEFT JOIN " + nameof(HPV_AgrupacionesPLVCabeceras) + " ON " + nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.idAgrupacionPLVCabecera) + " = " + nameof(HPV_AgrupacionesPLVCabeceras) + "." + nameof(HPV_AgrupacionesPLVCabeceras.id)
                                  )
                              : ("")
                      ) +
                      " WHERE " + nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.fechaBorrado) + " IS null AND " +
                          " ( " + nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.idEmpresa) + "=@idEmpresa" +
                              (
                                  (_lst_idEmpresasRelacionadas != null && _lst_idEmpresasRelacionadas.Count > 0)
                                      ? (" OR " + nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.idEmpresa) + " in (" + str_Filtros_Empresas + ") ")
                                      : " "
                              ) +
                          " ) AND " +
                          (_lng_id > -1 ? nameof(HPV_Perfiles) + "." + (nameof(HPV_Perfiles.id) + "=@id") : "1 = 1") + " AND " +
                          //Filtro por datos del padre relacionado
                          (
                              !str_Padre_Opcion.Equals("")
                                  //Empresa
                                  ? str_Padre_Opcion.Equals(Variables.G_STR_OPCION_GEN_EMPRESA)
                                      ? (nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.idEmpresa) + "=@id_Padre")
                                      : ("1 = 1")
                                  : ("1 = 1")
                          );

                //Parametros
                lst_Parametros.Add(new SqlParameter("@idEmpresa", _lng_idEmpresaSeleccionada));
                lst_Parametros.Add(new SqlParameter("@id", _lng_id));
                lst_Parametros.Add(new SqlParameter("@id_Padre", lng_Padre_id));

                object[] arr_Parametros = lst_Parametros.ToArray();

                //Rellenar el Modelo
                g_lst_INTERNO_HPV_Perfiles_Listado_Modelo = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_HPV_Perfiles_Listado_Modelo>(str_SQL, arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Perfiles_Datos) + "/" + nameof(ConsultaRellenar_Listado), true);
            }
        }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        private INTERNO_HPV_Perfiles_Listado_Modelo g_mdl_INTERNO_HPV_Perfiles_Listado_Modelo_F3 = null;

        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_HPV = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Consulta ......................................................
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(HPV_Perfiles).Name), _str_CampoBusqueda, _str_filtro, -1, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if (g_mdl_INTERNO_HPV_Perfiles_Listado_Modelo_F3 != null)
                {
                    dnm_HPV = g_mdl_INTERNO_HPV_Perfiles_Listado_Modelo_F3;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Perfiles_Datos) + "/" + nameof(Obtener_F3), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_HPV;
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_HPV = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Consulta ......................................................
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(HPV_Perfiles).Name), "", "", _lng_id, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if (g_mdl_INTERNO_HPV_Perfiles_Listado_Modelo_F3 != null)
                {
                    dnm_HPV = g_mdl_INTERNO_HPV_Perfiles_Listado_Modelo_F3;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Perfiles_Datos) + "/" + nameof(Obtener_F3), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_HPV;
        }
        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                string str_Filtros_Empresas = Funciones.Formar_ContenidoIN_ParaConsultaWhere(_lst_idEmpresasRelacionadas);

                //Filtros de Opciones
                //Datos del Padre si los tuviera .........................
                long lng_Padre_id = -1;
                string str_Padre_Opcion = "";
                if (_lst_INTERNO_Filtro_OpcionPadre_Modelo != null && _lst_INTERNO_Filtro_OpcionPadre_Modelo.Count > 0)
                {
                    lng_Padre_id = _lst_INTERNO_Filtro_OpcionPadre_Modelo[0].VALOR;
                    str_Padre_Opcion = _lst_INTERNO_Filtro_OpcionPadre_Modelo[0].NOMBRE_CAMPO;
                }

                string str_SQL =
                     " SELECT distinct " +
                         nameof(INTERNO_HPV_Perfiles_Listado_Modelo.id) + " = " + nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.id) + "," +
                         nameof(INTERNO_HPV_Perfiles_Listado_Modelo.codigo) + " = " + nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.codigo) + "," +
                         nameof(INTERNO_HPV_Perfiles_Listado_Modelo.descripcion) + " = " + nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.descripcion) +
                 " FROM " + nameof(HPV_Perfiles) +
                 " WHERE " + nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.fechaBorrado) + " IS null AND " +
                          " ( " + nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.idEmpresa) + "=@idEmpresa" +
                               (
                                   (_lst_idEmpresasRelacionadas != null && _lst_idEmpresasRelacionadas.Count > 0)
                                       ? (" OR " + nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.idEmpresa) + " in (" + str_Filtros_Empresas + ") ")
                                       : " "
                               ) +
                           " ) AND " +
                         (
                          (_lng_id > -1)
                            ? (nameof(HPV_Perfiles.id) + " = " + _lng_id)
                            : (
                                 //Filtrar por Codigo
                                 (_str_CampoBusqueda.Equals(nameof(HPV_Perfiles.codigo)))
                                     ? (nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.codigo) + "=@Filtro")
                                     //Filtrar por Descripcion
                                     : (nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.descripcion) + "=@Filtro")
                              )
                         )
                         + " AND " +
                         //Filtro por datos del padre relacionado
                         (
                             !str_Padre_Opcion.Equals("")
                                 //Empresa
                                 ? str_Padre_Opcion.Equals(Variables.G_STR_OPCION_GEN_EMPRESA)
                                     ? (nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.idEmpresa) + "=@id_Padre")
                                     : ("1 = 1")
                                 : ("1 = 1")
                         );

                //Parametros
                lst_Parametros.Add(new SqlParameter("@idEmpresa", _lng_idEmpresaSeleccionada));
                lst_Parametros.Add(new SqlParameter("@Filtro", _str_Filtro));
                lst_Parametros.Add(new SqlParameter("@id_Padre", lng_Padre_id));

                object[] arr_Parametros = lst_Parametros.ToArray();

                //Rellenar el Modelo
                g_mdl_INTERNO_HPV_Perfiles_Listado_Modelo_F3 = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_HPV_Perfiles_Listado_Modelo>(str_SQL, arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Perfiles_Datos) + "/" + nameof(ConsultaRellenar_F3), true);
            }
        }
        #endregion

        #region Obtener
        private dynamic g_dnm_Modelo_Obtener = null;
        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                  " SELECT " +
                      nameof(INTERNO_MantenimientoSimple_Modelo.id) + " = " + nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.id) + "," +
                      nameof(INTERNO_MantenimientoSimple_Modelo.codigo) + " = " + nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.codigo) + "," +
                      nameof(INTERNO_MantenimientoSimple_Modelo.descripcion) + " = " + nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.descripcion) + "," +
                      nameof(INTERNO_MantenimientoSimple_Modelo.fechaBorrado) + " = " + nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.fechaBorrado) + "," +
                      nameof(INTERNO_MantenimientoSimple_Modelo.idEmpresa) + " = " + nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.idEmpresa) + "," +
                      //AgrupacionesPLVCabecera
                      nameof(INTERNO_MantenimientoSimple_Modelo.F3_id) + " = " + nameof(HPV_AgrupacionesPLVCabeceras) + "." + nameof(HPV_AgrupacionesPLVCabeceras.id) + "," +
                      nameof(INTERNO_MantenimientoSimple_Modelo.F3_Codigo) + " = " + nameof(HPV_AgrupacionesPLVCabeceras) + "." + nameof(HPV_AgrupacionesPLVCabeceras.codigo) + "," +
                      nameof(INTERNO_MantenimientoSimple_Modelo.F3_Descripcion) + " = " + nameof(HPV_AgrupacionesPLVCabeceras) + "." + nameof(HPV_AgrupacionesPLVCabeceras.descripcion) + "," +
                      nameof(INTERNO_MantenimientoSimple_Modelo.F3_FechaBorrado) + " = " + nameof(HPV_AgrupacionesPLVCabeceras) + "." + nameof(HPV_AgrupacionesPLVCabeceras.fechaBorrado) +
              " FROM " + nameof(HPV_Perfiles) +
              //AgrupacionesPLVCabecera
              " LEFT JOIN " + nameof(HPV_AgrupacionesPLVCabeceras) + " ON " + nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.idAgrupacionPLVCabecera) + " = " + nameof(HPV_AgrupacionesPLVCabeceras) + "." + nameof(HPV_AgrupacionesPLVCabeceras.id) +
              " WHERE " + nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.fechaBorrado) + " IS null AND " +
                          nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<INTERNO_MantenimientoSimple_Modelo>(str_SQL, arr_Parametros).FirstOrDefault();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Perfiles_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }
        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }

        public bool Existe_PorAgrupacionPLVCabecera(long _lng_idAgrupacionPLVCabecera, Exferia_Entities _obj_Exferia_Entities)
        {
            bool bol_Existe = false;
            HPV_Perfiles mdl_HPV_Perfiles = null;

            try
            {
                string str_SQL =
                 " SELECT distinct " +
                     nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.id) + "," +
                     nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.codigo) + "," +
                     nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.descripcion) + "," +
                     nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.fechaBorrado) + "," +
                     nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.idEmpresa) + "," +
                     nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.idAgrupacionPLVCabecera) + "," +
                 " FROM " + nameof(HPV_Perfiles) +
                 " WHERE " + nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.fechaBorrado) + " IS null AND " +
                         " ( NOT" + nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.idAgrupacionPLVCabecera) + " IS NULL ) AND " +
                          nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.idAgrupacionPLVCabecera) + "=@idAgrupacionPLVCabecera ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idAgrupacionPLVCabecera",  _lng_idAgrupacionPLVCabecera)
                };

                //Rellenar el Modelo
                mdl_HPV_Perfiles = _obj_Exferia_Entities.Database.SqlQuery<HPV_Perfiles>(str_SQL, arr_Parametros).FirstOrDefault();

                if(mdl_HPV_Perfiles != null)
                {
                    bol_Existe = true;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Perfiles_Datos) + "/" + nameof(Existe_PorAgrupacionPLVCabecera), true);
            }

            return bol_Existe;
        }

        #endregion

        #region MODELOS

        #region Modelo Simple
        private HPV_Perfiles g_mdl_HPV_Perfiles = null;
        public HPV_Perfiles Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                  //WHERE
                                  " WHERE " + nameof(HPV_Perfiles) + "." + nameof(HPV_Perfiles.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Perfiles_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_HPV_Perfiles;
        }

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                             object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_HPV_Perfiles = obj_Exferia_Entities.Database.SqlQuery<HPV_Perfiles>(_str_SQL, _arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Perfiles_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
               " SELECT " +
                   nameof(HPV_Perfiles.id) + "," +
                   nameof(HPV_Perfiles.codigo) + "," +
                   nameof(HPV_Perfiles.descripcion) + "," +
                   nameof(HPV_Perfiles.idEmpresa) + "," +
                   nameof(HPV_Perfiles.fechaBorrado) + "," +
                   nameof(HPV_Perfiles.idAgrupacionPLVCabecera) +
               " FROM " + nameof(HPV_Perfiles);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;
            
            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                INTERNO_MantenimientoSimple_Modelo mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar = (INTERNO_MantenimientoSimple_Modelo)_mdl_obj;
                HPV_Perfiles mdl_HPV_Perfiles_DatosViejos = new HPV_Perfiles();

                // Ver si existe ######################################################################
                HPV_Perfiles mdl_HPV_Perfiles_Final = Obtener_Modelo_Por_Id(mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.id);
                //######################################################################################

                //UPDATE
                if (mdl_HPV_Perfiles_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_HPV_Perfiles_Final, mdl_HPV_Perfiles_DatosViejos, false, false);

                    //Cargar los Datos del Modelo
                    Cargar_DatosModelo(mdl_HPV_Perfiles_Final, mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar);

                    #region UPDATE
                    string str_SQL_Update = " UPDATE " + nameof(HPV_Perfiles) +
                                            " SET " +
                                                nameof(HPV_Perfiles.codigo) + "=@codigo," +
                                                nameof(HPV_Perfiles.descripcion) + "=@descripcion," +
                                                nameof(HPV_Perfiles.idEmpresa) + "=@idEmpresa," +
                                                nameof(HPV_Perfiles.fechaBorrado) + "=@fechaBorrado," +
                                                nameof(HPV_Perfiles.idAgrupacionPLVCabecera) + "=@idAgrupacionPLVCabecera" +
                                            " WHERE " +
                                                nameof(HPV_Perfiles.id) + "=@id";

                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@codigo",  mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.codigo),
                        new SqlParameter("@descripcion",  mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.descripcion),
                        new SqlParameter("@idEmpresa",  mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.idEmpresa),
                        mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                        mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.F3_id > -1
                            ?   new SqlParameter("@idAgrupacionPLVCabecera", mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.F3_id.Value)
                            :   new SqlParameter("@idAgrupacionPLVCabecera",  DBNull.Value),
                        new SqlParameter("@id",  mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_ValorDevuelto_Modelo.Id = mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.id;
                }
                //INSERT
                else
                {
                    mdl_HPV_Perfiles_Final = new HPV_Perfiles();

                    //Tipo de Accion que se va a realizar
                    mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_INSERTAR;

                    //Cargar los Datos del Modelo
                    Cargar_DatosModelo(mdl_HPV_Perfiles_Final, mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(HPV_Perfiles) +
                                               " (" +
                                                       nameof(HPV_Perfiles.codigo) + "," +
                                                       nameof(HPV_Perfiles.descripcion) + "," +
                                                       nameof(HPV_Perfiles.idEmpresa) + "," +
                                                       nameof(HPV_Perfiles.fechaBorrado) + "," +
                                                       nameof(HPV_Perfiles.idAgrupacionPLVCabecera) +
                                               " ) " +
                                               " OUTPUT INSERTED." + nameof(HPV_Perfiles.id) +
                                               " VALUES " +
                                               " ( " +
                                                   "@codigo," +
                                                   "@descripcion," +
                                                   "@idEmpresa," +
                                                   "@fechaBorrado," +
                                                   "@idAgrupacionPLVCabecera" +
                                               " ) ";

                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@codigo",  mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.codigo),
                        new SqlParameter("@descripcion",  mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.descripcion),
                        new SqlParameter("@idEmpresa",  mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.idEmpresa),
                        mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                        mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.F3_id > -1
                            ?   new SqlParameter("@idAgrupacionPLVCabecera", mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.F3_id.Value)
                            :   new SqlParameter("@idAgrupacionPLVCabecera",  DBNull.Value)
                    };
                    #endregion

                    //Id de la tabla
                    mdl_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(HPV_Perfiles), mdl_HPV_Perfiles_DatosViejos, mdl_HPV_Perfiles_Final, mdl_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Perfiles_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                //Finalizar transaccion
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }

        private void Cargar_DatosModelo(HPV_Perfiles _mdl_HPV_Perfiles, INTERNO_MantenimientoSimple_Modelo _mdl_INTERNO_MantenimientoSimple_Modelo)
        {
            // Cargar los Datos Nuevos del Modelo
            _mdl_HPV_Perfiles.id = _mdl_INTERNO_MantenimientoSimple_Modelo.id;
            _mdl_HPV_Perfiles.codigo = _mdl_INTERNO_MantenimientoSimple_Modelo.codigo;
            _mdl_HPV_Perfiles.descripcion = _mdl_INTERNO_MantenimientoSimple_Modelo.descripcion;
            _mdl_HPV_Perfiles.idEmpresa = _mdl_INTERNO_MantenimientoSimple_Modelo.idEmpresa;
            _mdl_HPV_Perfiles.idAgrupacionPLVCabecera = _mdl_INTERNO_MantenimientoSimple_Modelo.F3_id;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR;

            HPV_Perfiles mdl_HPV_Perfiles_Final = null;
            
            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Comprobar si existe en algun Terminal con este perfil antes de borrar
                HPV_Terminales_Datos obj_HPV_Terminales_Datos = new HPV_Terminales_Datos();
                bool bol_Existe_EnTerminales = obj_HPV_Terminales_Datos.Existe_PorPerfil(_lng_id, obj_Exferia_Entities);

                if (bol_Existe_EnTerminales)
                {
                    mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                    mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_PERFILES_VALIDACION_EXISTERELACION_TERMINALES;
                }
                else
                {
                    // Ver si existe ######################################################################
                    HPV_Perfiles mdl_HPV_Perfiless_Final = Obtener_Modelo_Por_Id(_lng_id);
                    //######################################################################################

                    if (mdl_HPV_Perfiless_Final != null)
                    {
                        #region UPDATE
                        string str_SQL_Update = " UPDATE " + nameof(HPV_Perfiles) +
                                                   " SET " +
                                                   nameof(HPV_Perfiles.fechaBorrado) + "=@fechaBorrado " +
                                               " WHERE " +
                                                   nameof(HPV_Perfiles.id) + "=@id";
                        //Parametros
                        object[] arr_Parametros_Update = new object[]
                        {
                        new SqlParameter("@fechaBorrado",  DateTime.Now),
                        new SqlParameter("@id", _lng_id)
                        };
                        #endregion

                        //Update
                        obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                        //Grabar un registro de trazabilidad con los datos de la trasaccion realizada
                        Datos_Generales.USR_Trazabilidad_Grabar(typeof(HPV_Perfiles), null, mdl_HPV_Perfiles_Final, Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                    }
                }
                    
                //Devolver tambien el Objeto
                mdl_ValorDevuelto_Modelo.Id = _lng_id; 
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Perfiles_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            throw new NotImplementedException();
        }
        #endregion
        

    }
}
